%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%The optimization of Elementary Mode Coefficients(EMCs) by Maximum Entropy Principle% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function optimization
clear all
global nd numberem nem fluxv

load MEP_optimization
tic
disp('Preparing for optimization matrix')

nd=1;
for i=1:1:nd
    emmatrix=Unique_cEM (1,:);%emmatrix=reaction with the measured / experimental flux 
   fluxv(1,i)=flux(1,i);
end
[numberr,numberem]=size(Unique_cEM );
% numberr:the number of reactions
% numberem: number of Elementary mode

%Normalization of EM matrix of optimization
uptakeb=Unique_cEM (numuptake,:);       %%%
for i=1:1:numberem              %%%
    if uptakeb(1,i)==0          %%%
        uptakeb(1,i)=1;         %%%
    end                         %%%
end                             %%%
for j=1:1:nd
    nem(j,:)=emmatrix(j,:)*uptakeflux./uptakeb;
    for i=1:1:numberem
        if Unique_cEM (numuptake,i)==0
            nem(j,i)=0;
        end
    end
end

disp('optimization is beginning')

x0=zeros(nd,1);
%[x,fval,EXITFLAG,options]=fsolve(@func,x0)
[x,fval,EXITFLAG,options]=mmfsolve(@func,x0)
zzz=0;
sss=zeros(numberem,1);
%sss=0;
for i=1:1:numberem
    for j=1:1:nd
        sss(i,1)=sss(i,1)+x(j,1)*nem(j,i);
    end
        zzz=zzz+exp(-sss(i,1));   
end
fai=exp(-sss)/zzz;
cEMC=fai*uptakeflux./uptakeb';
for i=1:1:numberem
    if Unique_cEM (numuptake,i)==0
    cEMC(i,1)=eps;
    end
end

Predflux=Unique_cEM *cEMC;
disp('Flux distribution is: ')
disp(Predflux)

save Predictedflux.mat Predflux cEMC
disp('Optimization is successful. You can close it now.')
toc

function f=func(y)
global nd numberem nem fluxv
z=0;
for i=1:1:numberem
    s=0;
    for j=1:1:nd
        s=s+y(j,1)*nem(j,i);
    end
        z=z+exp(-s);
end
za=zeros(nd,1);
for k=1:1:nd
for i=1:1:numberem    
    s=0;
    for j=1:1:nd
         s=s+y(j,1)*nem(j,i);
    end
        
        za(k,1)=za(k,1)+nem(k,i)*exp(-s);        
end
f(k,1)=(za(k,1)/z)-fluxv(1,k);
end


